#include	<config.h>
#if HAVE_STRING_H
# if !STDC_HEADERS && HAVE_MEMORY_H
#  include	<memory.h>
# endif
# include	<string.h>
#endif
#include	"restyp.h"

struct restyp2ext
{
	unsigned short typ;
	char* ext;
};

static const struct restyp2ext r2e[] =
{
	{ RR_1DA, "1da" },	/* bogus, I know */
	{ RR_2DA, "2da" },
	{ RR_4PC, "4pc" },
	{ RR_ARE, "are" },	/* area */
	{ RR_BIC, "bic" },
	{ RR_BMP, "bmp" },	/* windows BMP pixmap */
	{ RR_BTD, "btd" },
	{ RR_BTE, "bte" },
	{ RR_BTG, "btg" },
	{ RR_BTI, "bti" },
	{ RR_BTM, "btm" },
	{ RR_BTP, "btp" },
	{ RR_CCS, "ccs" },
	{ RR_CSS, "css" },
	{ RR_DDS, "dds" },
	{ RR_DFT, "dft" },
	{ RR_DLG, "dlg" },	/* dialog tree */
	{ RR_DWK, "dwk" },
	{ RR_FAC, "fac" },	/* faction data */
	{ RR_GFF, "gff" },
	{ RR_GIC, "gic" },
	{ RR_GIT, "git" },
	{ RR_GUI, "gui" },
	{ RR_IFO, "ifo" },	/* module info */
	{ RR_INI, "ini" },	/* generic initialization text */
	{ RR_ITP, "itp" },
	{ RR_JRL, "jrl" },	/* journal data ? */
	{ RR_LTR, "ltr" },
	{ RR_MDL, "mdl" },	/* model data */
	{ RR_MOD, "mod" },	/* module */
	{ RR_MP3, "mp3" },	/* MP3-format audio */
	{ RR_MVE, "mve" },	/* movie */
	{ RR_NCS, "ncs" },	/* neverwinter script compiled */
	{ RR_NSS, "nss" },	/* neverwinter script source */
	{ RR_PLT, "plt" },
	{ RR_PTT, "ptt" },	/* plot template */
	{ RR_PWK, "pwk" },
	{ RR_RES, "res" },	/* unspecified resource type */
	{ RR_SAV, "sav" },	/* save file */
	{ RR_SET, "set" },
	{ RR_SSF, "ssf" },
	{ RR_TGA, "tga" },	/* targa pixmap */
	{ RR_TLK, "tlk" },	/* generic string vector */
	{ RR_TXI, "txi" },
	{ RR_TXT, "txt" },	/* generic text */
	{ RR_UTC, "utc" },
	{ RR_UTD, "utd" },
	{ RR_UTE, "ute" },
	{ RR_UTG, "utg" },
	{ RR_UTI, "uti" },
	{ RR_UTM, "utm" },
	{ RR_UTP, "utp" },
	{ RR_UTS, "uts" },
	{ RR_UTT, "utt" },
	{ RR_UTW, "utw" },
	{ RR_WAV, "wav" },	/* WAV-format audio */
	{ RR_WOK, "wok" },
};
static const int nr2e = sizeof r2e / sizeof r2e[0];

const char* typ2ext(unsigned short typ)
{
	int i;

	for (i = 0; i < nr2e; ++i)
	{
		if (typ == r2e[i].typ)
			return r2e[i].ext;
	}
	return "???";
}

unsigned short ext2typ(const char* ext)
{
	int i;

	for (i = 0; i < nr2e; ++i)
	{
		if (strcmp(ext, r2e[i].ext) == 0)
			return r2e[i].typ;
	}
	return -1;
}
